//(C) Andrew Smirnow
#include <Servo.h>
#include <NewPing.h>
#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_ADXL345_U.h>

#define TRIGGER_PIN  10
#define ECHO_PIN     11
#define SERVO_PIN    8
#define SUBSERVO_PIN 9
#define MAX_DISTANCE 200
#define SERVO_DELAY  30
#define BT Serial
#define toLeft true
#define toRight false
#define accelDia 0.5

Adafruit_ADXL345_Unified accel = Adafruit_ADXL345_Unified(12345);
NewPing sonar(TRIGGER_PIN, ECHO_PIN, MAX_DISTANCE);
Servo myServo;

int thisPos = 0;
bool thisDir = toLeft;
bool act = false;
float accelAverage;

void setup() {
  BT.begin(9600);
  //BT.println("fghfghfghfghfghfgh");
  //while(BT.available()>0) {;}
  myServo.attach(SERVO_PIN);
  if(!accel.begin())
  {
    BT.println("Ooops, no ADXL345 detected ... Check your wiring!");
    while(1);
  } // else BT.println("OK");
  accel.setRange(ADXL345_RANGE_16_G);
  accelAverage = accelCalibrate();
  pinMode(9, INPUT);
  pinMode(2, INPUT);
}

void loop(){
  if (!accelCheck()) BT.print("-1,1.");
  radar();
}

void radar(){
  if(BT.available() > 0){
    char inByte = BT.read();
    if(inByte = '!'){
      if (!act) act = true;
      else act = false;
    }
  }
  if(act){
      if(thisDir == toLeft && thisPos == 151) {
      thisPos = thisPos - 2;
      thisDir = toRight;    
    }
  
    if(thisDir == toRight && thisPos == -1) {
      thisPos = thisPos + 2;
      thisDir = toLeft;
    }
    
    if(thisDir){
      myServo.write(thisPos);
      delay(SERVO_DELAY);
      BT.print(thisPos + 15);
      BT.print(",");
      BT.print(sonar.ping_cm());
      BT.print(".");
      thisPos++;
    }
    else {
      myServo.write(thisPos);
      delay(SERVO_DELAY);
      BT.print(thisPos + 15);
      BT.print(",");
      BT.print(sonar.ping_cm());
      BT.print(".");
      thisPos--;
    }
  }
}

float accelCalibrate() 
{
  sensors_event_t event; 
  accel.getEvent(&event);
  float accelTmp = 0;
  for (int i = 0; i < 10; i++){
    accelTmp += event.acceleration.y;
    delay(50);
  }
  return accelTmp/10;
}

bool accelCheck(){
  if(digitalRead(9) or digitalRead(2)){
    //если двигаемся
  } else {
    sensors_event_t event; 
    accel.getEvent(&event);
    if (event.acceleration.y > accelAverage + accelDia or event.acceleration.y < accelAverage - accelDia) return false;
    else return true;
  }
}

